#include "config.h"
#include "reffile.h"
#include "loadfile.h"
#include "cdbslib.h"
#include "mkload.h"
#include "cdbserror.h"

/* READ_HEADER -- Read observation mode fields from the reference file header
 *                  (these will be file selection fields only,
 *                   row selection fields won't be found in the header)
 *
 * i: ref	reference file descriptor
 * i: obsmode	list of observation mode field names
 * o: obsvals	list of observation mode values
 */

void read_header (reffile *ref, textbuf *obsmode, textbuf *obsvals)
{
    int		ikey;
    char	*keyword;
    char	value[SZ_STRING+1];

    init_text (obsvals, 20, 200);

    for (ikey = 0; (keyword = get_text (obsmode, ikey)) != NULL; ikey ++) {
        cdbs_debug("read_header: search for %s", keyword);
        if (get_hdr_reffile (ref, keyword, value, SZ_STRING) == ERR) {
            // row selection fields will not be found in the header, so
            // make them \n strings for now
            cdbs_debug("WARNING - read_header: value for keyword "
                       "%s not found (normal for row select fields)\n", 
                       keyword);
	    safecopy (value, "\n", SZ_STRING);
        }

        add_text (obsvals, value);
    }
}
